<?php
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: BaseExpress
// Copyright (C) 2003 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://www.widgetbox.net/
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:
// Contains the InitialExpress and baseExpress objects on which all the other object are based on.
// BaseExpress inherits from InitialExpress and forwards it function to the Debugclass
//
// ----------------------------------------------------------------------

class InitialExpress
{

  function callClass($class_to_call)
  {
    return new $class_to_call();
  }
}

class BaseExpress extends InitialExpress
{
  var $Debug;
  function BaseExpress()
   {
     if (pnModGetVar('ContentExpress', 'debugflag') <> 1){
       $this->Debug = parent::callClass('DebugExpress');
     }
   }

  function init($dbconn)
  {
    pnModSetVar('ContentExpress', 'debug_flag', 1 );
    return true;
  }

  function upgrade($oldversion)
  {
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    switch($oldversion) {
      case "1.2.6.0":
        pnModSetVar('ContentExpress', 'debug_flag', 1);
      break;
    }
    return true;
  }

  function remove()
  {
    pnModDelVar('ContentExpress', 'debug_flag' );

    return true;
  }

  function getDebugOutput(){
    $debugsetting = pnModGetVar('ContentExpress', 'debug_flag');
    //list all debuglevels except the 'none' level of course
    if ($debugsetting > 1){
      $debugoutput = $this->Debug->getDebugOutput();
    }
    return $debugoutput;
  }

  function dump($var, $val,$debugflag ,$listoutput=true){
    //only allow the ALL flag or the current debugflag
    $debugsetting = pnModGetVar('ContentExpress', 'debug_flag');
    if (( $debugsetting == $debugflag) || ($debugsetting == 2)){
       $this->Debug->dump($var,$val,$debugflag,$listoutput);
    }
    return true;
  }

  function initDebug()
  {
    if (pnModGetVar('ContentExpress', 'debug_flag') <> 1){
       $this->Debug->initDebug();
    }
    return true;
  }

    function startTimer($id,$debugflag)
  {
    $debugsetting = pnModGetVar('ContentExpress', 'debug_flag');
    if (( $debugsetting == $debugflag) || ($debugsetting == 2)){
       $this->Debug->startTimer($id);
    }
    return true;
  }

    function stopTimer($id,$debugflag)
  {
    $debugsetting = pnModGetVar('ContentExpress', 'debug_flag');
    if (( $debugsetting == $debugflag) || ($debugsetting == 2)){
       $this->Debug->stopTimer($id);
    }
    return true;
  }

  function getTime($id,$debugflag)
  {
    $debugsetting = pnModGetVar('ContentExpress', 'debug_flag');
    if (( $debugsetting == $debugflag) || ($debugsetting == 2)){
       $this->Debug->getTime($id);
    }
    return true;
  }

    function setValue( $field, $value ) {}
    function getValue( $field ) {}
}
?>
